﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private db As database
	Private lblaccountnumber As Label
	Private lblname As Label
	Private Panel1 As Panel
	Public clvdash As CustomListView
	Private catpage As CategoryPage
	Private setpage As SettingsPage
	Private budpage As BudgetPage
	Private pnlnav1 As Panel
	Private pnlnav2 As Panel
	Private pnlnav3 As Panel
	Private pnlnav4 As Panel
	Private pnlnav5 As Panel
	Public selected_account As Int
	Private lblaccountbalance As Label
	Private ftf1 As B4XFloatTextField
	Private ftf2 As B4XFloatTextField
	Private ftf3 As B4XFloatTextField
	Private accdialog As B4XDialog
	Private btnedit As Button
	Private lblcurr As Label
	Public opendialog As B4XDialog
	Private ftf_wachtwoord As B4XFloatTextField
	Private ftfnaam As B4XFloatTextField
	Public login_ok As Boolean = False
End Sub

Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub

private Sub show_opendialog
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.SetLayoutAnimated(0, 0, 0, 300dip, 190dip)
	pnl.LoadLayout("opendialog_layout")
	Dim rs As ResumableSub =  opendialog.ShowCustom(pnl, "OK", "", "")
	ftfnaam.text = ""
	ftf_wachtwoord.Text = ""
	Wait For (rs) Complete (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		If ftfnaam.text = "b4x" And ftf_wachtwoord.text = "b4xbudget" Then
			login_ok = True
			B4XPages.ShowPageAndRemovePreviousPages("MainPage")
		Else
			login_ok = False
		End If
	End If
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me,"Budget with accounts")
	opendialog.Initialize(Root)
	opendialog.PutAtTop = True
	opendialog.BackgroundColor = Colors.LightGray
	show_opendialog
	db.Initialize("budget_with_accounts","budget_db",True,False)
	create_tables
	catpage.Initialize
	B4XPages.AddPage("Category",catpage)
	setpage.Initialize
	B4XPages.AddPage("Settings",setpage)
	budpage.Initialize
	B4XPages.AddPage("Budget",budpage)
	accdialog.Initialize(Root)
	accdialog.PutAtTop = True
	accdialog.BackgroundColor = Colors.LightGray
	accdialog.BodyTextColor = Colors.Blue
End Sub

private Sub B4XPage_Appear
	set_panel_colors(pnlnav1,Colors.Blue,Colors.Blue)
	clvdash.Clear
	If login_ok <> True Then
		Return
	End If
	If db.get_num_rows("settings") < 1 Then
		Private sql As String = "SELECT rowid, name, accountnumber, note"
		sql = sql & " FROM accounts"
		Private rs1 As ResultSet = db.select_query(sql)
		Do While rs1.NextRow
			Dim pnl As Panel = set_clvdashitem(rs1.GetString("name"),rs1.GetString("accountnumber"),rs1.GetString("note"),rs1.GetString("rowid"),"")
			clvdash.Add(pnl,rs1.GetString("rowid"))
		Loop
	Else
		Private sql As String = "SELECT rowid, name, accountnumber, note"
		sql = sql & " FROM accounts"
		Private rs1 As ResultSet = db.select_query(sql)
		Do While rs1.NextRow
			' settings for account?
			Private sql As String = "SELECT count(*) as numrecs"
			sql = sql & " FROM settings WHERE account_id = ?"
			Private idarr() As String = Array As String(rs1.GetString("rowid"))
			Private rs2  As ResultSet = db.select_query_prepared(sql,idarr)
			rs2.NextRow
			If rs2.GetString("numrecs") < 1 Then
				Dim pnl As Panel = set_clvdashitem(rs1.GetString("name"),rs1.GetString("accountnumber"),rs1.GetString("note"),rs1.GetString("rowid"),"")
				clvdash.Add(pnl,rs1.GetString("rowid"))
			Else			
				Private sql As String = "SELECT currency"
				sql = sql & " FROM settings"
				sql = sql & " WHERE settings.account_id = " & rs1.GetString("rowid")
				Private rs3 As ResultSet = db.select_query(sql)
				rs3.NextRow
				Dim pnl As Panel = set_clvdashitem(rs1.GetString("name"),rs1.GetString("accountnumber"),rs1.GetString("note"),rs1.GetString("rowid"),rs3.GetString("currency"))
				clvdash.Add(pnl,rs1.GetString("rowid"))			
			End If
		Loop
	End If
	selected_account = 0
End Sub

Private Sub create_tables
	If db.table_exists("expenses") = False Then
		Private sql As String = "CREATE TABLE expenses (date TEXT, category_id INTEGER, description TEXT, amount TEXT, account_id INTEGER)"
		db.action_query(sql,Null)
	End If
	If db.table_exists("earnings") = False Then
		Private sql As String = "CREATE TABLE earnings (date TEXT, category_id INTEGER, description TEXT, amount TEXT, account_id INTEGER)"
		db.action_query(sql,Null)
	End If
	If db.table_exists("category") = False Then
		Private sql As String = "CREATE TABLE category (name TEXT, reference TEXT, account_id INTEGER, sequence INTEGER)"
		db.action_query(sql,Null)
	End If
	If db.table_exists("settings") = False Then
		Private sql As String = "CREATE TABLE settings (startdate TEXT, enddate TEXT, startbalance TEXT, currency TEXT, account_id INTEGER)"
		db.action_query(sql,Null)
	End If
	If db.table_exists("accounts") = False Then
		Private sql As String = "CREATE TABLE accounts (name TEXT, accountnumber TEXT, note TEXT)"
		db.action_query(sql,Null)
	End If
End Sub

Private Sub set_clvdashitem(strnm As String,stracc As String, strnote As String, id As Int, curr As String) As Panel
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0,0dip,0dip,clvdash.AsView.Width-2dip,99dip)
	p.LoadLayout("clvdashitem_layout")
	lblname.Text = strnm
	lblaccountnumber.Text = stracc
	lblcurr.text = curr
	Dim strbalance As String = NumberFormat2(get_balance_from_account(id),0,2,2,False)
	lblaccountbalance.Text = strbalance
	btnedit.Tag = id
	btnedit.Text = Chr(0x270D)
	Return p
End Sub
Private Sub get_balance_from_account(accid As Int) As String
	' settings for account?
	Private startbal As String = "0.00"
	Private sql As String = "SELECT count(*) as numrecs, startbalance"
	sql = sql & " FROM settings WHERE account_id = ?"
	Private idarr() As String = Array As String(accid)
	Private rs1  As ResultSet = db.select_query_prepared(sql,idarr)
	If rs1.NextRow Then
		If rs1.GetString("numrecs") < 1 Then
			'xui.MsgboxAsync("Add the settings first!","Add settings")
			Return "0.00"
		Else
			startbal = rs1.GetString("startbalance")
		End If
	End If
	'Log("settings added")
	If db.get_num_rows("settings") > 0 Then
		Private totalexpenses As String
		Private totalearnings As String
		Private balance As String
		totalexpenses = get_totalexpenses(accid)
		totalearnings = get_totalearnings(accid)
		balance = startbal + totalearnings - totalexpenses
		Return balance
	Else
		Return "0.00"
	End If
End Sub
Private Sub get_totalexpenses(accid As String) As String
	Private sql As String = "SELECT count(*) as numrecs"
	sql = sql & " FROM expenses"
	sql = sql & " WHERE account_id = " & accid
	Private rs1 As ResultSet = db.select_query(sql)
	rs1.NextRow
	If rs1.GetString("numrecs") < 1 Then
		Return "0.00"
	End If
	Private total As String = ""
	Private sql As String = "SELECT sum(amount) as totalexpenses"
	sql = sql & " FROM expenses,accounts,settings"
	sql = sql & " WHERE expenses.account_id = " & accid
	sql = sql & " AND expenses.account_id = accounts.rowid"
	sql = sql & " AND accounts.rowid = settings.account_id"
	sql = sql & " AND date >= settings.startdate"
	Private rs1 As ResultSet = db.select_query(sql)
	If rs1.NextRow Then
		If rs1.GetString("totalexpenses") <> Null Then
			total = NumberFormat2(rs1.GetString("totalexpenses"),0,2,2,False)
			'Log(total)
			Return total
		Else
			Return "0.00"		
		End If
	Else
		Return "0.00"
	End If
End Sub
Private Sub get_totalearnings(accid As String) As String
	Private sql As String = "SELECT count(*) as numrecs"
	sql = sql & " FROM earnings"
	sql = sql & " WHERE account_id = " & accid
	Private rs1 As ResultSet = db.select_query(sql)
	rs1.NextRow
	If rs1.GetString("numrecs") < 1 Then
		Return "0.00"
	End If
	Private total As String = ""
	Private sql As String = "SELECT sum(amount) as totalearnings"
	sql = sql & " FROM earnings,accounts,settings"
	sql = sql & " WHERE earnings.account_id = " & accid
	sql = sql & " AND earnings.account_id = accounts.rowid"
	sql = sql & " AND accounts.rowid = settings.account_id"
	sql = sql & " AND date >= settings.startdate"
	Private rs1 As ResultSet = db.select_query(sql)
	If rs1.NextRow Then
		If rs1.GetString("totalearnings") <> Null Then
			total = NumberFormat2(rs1.GetString("totalearnings"),0,2,2,False)
			'Log(total)
			Return total
		Else
			Return "0.00"
		End If
	Else
		Return "0.00"
	End If
End Sub
Private Sub show_balance_Click
	Dim lbl As Label = Sender
	lbl.Color = Colors.Black
	Sleep(1000)
	lbl.Color = Colors.White
End Sub
Private Sub clvdash_ItemClick (Index As Int, Value As Object)
	selected_account = Value
	B4XPages.ShowPageAndRemovePreviousPages("Budget")
End Sub

Private Sub btnedit_Click
	Dim btn As Button = Sender
	show_change_dialog("accounts",btn.tag,"account",Colors.ARGB(100,182,221,249))
	selected_account = btn.tag
End Sub

Public Sub pnlNavigation_Click
	' check the files manager for the fonts that are needed!!!
	Dim pnlClicked As Panel = Sender
	set_colors(pnlClicked)
	If login_ok Then
		take_action(pnlClicked.Tag)
	Else
		xui.MsgboxAsync("Your login name and/or password was not correct!","Login")
		Sleep(0)
		show_opendialog
	End If
End Sub
Private Sub set_panel_colors(pnl As Panel,clr1 As Int,clr2 As Int)
	Dim lbl As Label = pnl.GetView(0).As(Label)
	lbl.TextColor = clr1
	Dim lbl As Label = pnl.GetView(1).As(Label)
	lbl.TextColor = clr1
	If pnl.NumberOfViews > 2 Then
		Dim lbl As Label = pnl.GetView(2).As(Label)
		lbl.Color = clr2
	End If
End Sub
Private Sub set_colors(pnl As Panel)
	set_panel_colors(pnlnav1,Colors.Black,Colors.Black)
	set_panel_colors(pnlnav2,Colors.Black,Colors.Black)
	set_panel_colors(pnlnav3,Colors.Black,Colors.Black)
	set_panel_colors(pnlnav4,Colors.Black,Colors.Black)
	set_panel_colors(pnlnav5,Colors.Black,Colors.Black)
	set_panel_colors(pnl,Colors.Blue,Colors.Blue)
End Sub
Private Sub take_action(tag As String)
	If selected_account = 0 And tag <> "Add" And tag <> "Home" Then
		xui.MsgboxAsync("Select an account first!","Select account")
		Return
	End If
	Select tag
		Case "Home"
			B4XPages.ShowPageAndRemovePreviousPages("MainPage")
		Case "Add"
			B4XPages.ShowPageAndRemovePreviousPages("MainPage")
			show_add_dialog("accounts","account",Colors.ARGB(100,182,221,249))
		Case "Budget"
			B4XPages.ShowPageAndRemovePreviousPages("Budget")
		Case "Category"
			B4XPages.ShowPageAndRemovePreviousPages("Category")
		Case "Settings"
			B4XPages.ShowPageAndRemovePreviousPages("Settings")
	End Select
End Sub

Private Sub show_add_dialog(tablename As String, title As String,title_color As Int)
	'xui.MsgboxAsync("add account","Accounts")
	Dim fldlst As List = db.get_fieldnames(tablename)
	Dim pnl1 As Panel = setup_dialog("account_dialog_layout"," Add " & title,title_color)
	Dim rsub1 As ResumableSub =  accdialog.ShowCustom(pnl1, "OK", "", "CANCEL")
	ftf1.HintText = fldlst.Get(1)
	ftf1.Update
	ftf2.HintText = fldlst.Get(2)
	ftf2.update
	ftf3.HintText = fldlst.Get(3)
	ftf3.update
	Wait For (rsub1) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		If ftf1.Text <> "" Then
			db.add_record(tablename, Array As String(ftf1.Text,ftf2.Text,ftf3.Text))
		End If
	End If
	B4XPage_Appear
End Sub
Private Sub show_change_dialog(tablename As String,rowid As Int, title As String, title_color As Int)
	'xui.MsgboxAsync("change/delete account","Accounts")
	Dim fldlst As List = db.get_fieldnames(tablename)
	Dim pnl1 As Panel = setup_dialog("account_dialog_layout"," Edit/Delete " & title, title_color)
	Dim rsub1 As ResumableSub =  accdialog.ShowCustom(pnl1, "SAVE", "DELETE", "CANCEL")
	Private rs1 As ResultSet = db.find_record(tablename,rowid)
	If rs1.NextRow Then
		ftf1.Text = rs1.GetString(fldlst.Get(1))
		ftf2.Text = rs1.GetString(fldlst.Get(2))
		ftf3.Text = rs1.GetString(fldlst.Get(3))
	End If
	'ftf1.Text = rowid
	ftf1.HintText = fldlst.Get(1)
	ftf1.Update
	ftf2.HintText = fldlst.Get(2)
	ftf2.update
	ftf3.HintText = fldlst.Get(3)
	ftf3.update
	Wait For (rsub1) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		If ftf1.Text <> "" Then
			db.change_record(tablename, Array As String(ftf1.Text,ftf2.Text,ftf3.Text),rowid)
		End If
	else if Result = xui.dialogResponse_Negative Then
		Dim conf As Object = xui.Msgbox2Async("You are about to delete all records from this account. Are you sure?","Delete","Yes","Cancel","No",Null)
		Wait For (conf) Msgbox_Result (Result As Int)
		If Result = xui.DialogResponse_Positive Then
			' cascading delete
			cleanup_account(rowid)
			db.remove_record(tablename,rowid)
		End If
	End If
	B4XPage_Appear
End Sub
private Sub setup_dialog(strlayout As String,lbltext As String,lblcolor As Int) As Panel
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.SetLayoutAnimated(0, 0, 0, 340dip, 200dip)
	pnl.LoadLayout(strlayout)
	Dim lbl As Label
	lbl.Initialize("")
	lbl.Text = lbltext
	lbl.TextSize = 18
	lbl.TextColor = Colors.Black
	lbl.Color = lblcolor
	pnl.AddView(lbl,0,0dip,340dip,30dip)
	Return pnl
End Sub

Private Sub cleanup_account(id As Int)
	Private lst As List = Array As String(id)
	Private sql As String = "DELETE FROM expenses WHERE account_id = ?"
	db.action_query(sql,lst)
	Private sql As String = "DELETE FROM earnings WHERE account_id = ?"
	db.action_query(sql,lst)
	Private sql As String = "DELETE FROM category WHERE account_id = ?"
	db.action_query(sql,lst)
	Private sql As String = "DELETE FROM settings WHERE account_id = ?"
	db.action_query(sql,lst)
End Sub
