﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=11.5
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private db As database
	Private pnlnav1 As Panel
	Private pnlnav2 As Panel
	Private pnlnav3 As Panel
	Private pnlnav4 As Panel
	Private pnlnav5 As Panel
	Private cbxaccounts As B4XComboBox
	Public lblbalance As Label
	Public lblcurrency As Label
	Private th1 As TabHost
	Private clv1 As CustomListView
	Private lbltotalexpense As Label
	Private sbtn1 As SwiftButton
	Private clv2 As CustomListView
	Private lbltotalearning As Label
	Private sbtn2 As SwiftButton
	Private lblaccountname As Label
	Public strstartticks As String
	Public strendticks As String
	Public currticks As Long = DateTime.Now
	Public currmonth As Int = DateTime.GetMonth(currticks)
	Public curryear As Int = DateTime.GetYear(currticks)
	Public currday As Int = DateTime.GetDayOfMonth(currticks)
	Private cbx1 As B4XComboBox
	Private ftf1 As B4XFloatTextField
	Private ftf2 As B4XFloatTextField
	Private lbldate As Label
	Public strcurrency As String
	Public SelectedIndex As Int
	Public SelectedItem As String
	Public cbx1rowids As List
	Public old_amount As String
	Public upd_rowid As String
	Public dbdialog As B4XDialog
	Public strtablename As String
	Public lblseldate As Label
	Private caldialog As B4XDialog
	Public displayyear As Int
	Public displaymonth As Int
	Public setdate As String
	Private cal As calendar
	Private pnlcal As Panel
	Private	currentticks As Long = DateTime.Now
	Public currentmonth As Int = DateTime.GetMonth(currentticks)
	Public currentyear As Int = DateTime.GetYear(currentticks)
	Public currentday As Int = DateTime.GetDayOfMonth(currentticks)
	Private pnl1 As Panel
	Private lbl1 As Label
	Private lbl2 As Label
	Private lbl3 As Label
	Private lbl4 As Label
	Private lblcurr As Label
End Sub

Public Sub Initialize As Object
	Return Me
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("budget_layout")
	B4XPages.SetTitle(Me,"Budget with accounts - budget")
	db.Initialize("budget_with_accounts","budget_db",True,False)
	th1.AddTab("expenses","tab1_layout")
	th1.AddTab("earnings","tab2_layout")
	dbdialog.Initialize(Root)
	dbdialog.PutAtTop = True
	dbdialog.BackgroundColor = Colors.LightGray
	dbdialog.BodyTextColor = Colors.Blue
	strtablename = "expenses"
	cal.Initialize(Me,"cal")
	caldialog.Initialize(Root)
	caldialog.PutAtTop = True
	caldialog.BackgroundColor = Colors.White
	lblseldate.Initialize("")
	pnlcal.Initialize("")
	displayyear = currentyear
	displaymonth = currentmonth
	strstartticks = DateUtils.SetDate(curryear,currmonth,1)
	strendticks = DateUtils.SetDate(curryear,currmonth,DateUtils.NumberOfDaysInMonth(currmonth,curryear))
End Sub

Private Sub B4XPage_Appear
	set_colors(pnlnav3)
	If B4XPages.MainPage.selected_account = 0 Then
		Return
	End If
	lblbalance.Text = "0.00"
	strcurrency = ""
	If db.get_num_rows("accounts") > 0 Then
		Private sql As String = "SELECT rowid, name, accountnumber, note FROM accounts WHERE rowid = ?"
		Private id() As String = Array As String(B4XPages.MainPage.selected_account)
		Private rs1  As ResultSet = db.select_query_prepared(sql,id)
		If rs1.NextRow Then
			lblaccountname.Text = rs1.GetString("name") & " " & rs1.GetString("accountnumber")
			lblaccountname.Tag = rs1.GetString("rowid")
		End If
	End If
	'fill_cbxaccounts
	If db.get_num_rows("settings") > 0 Then
		Private sql As String = "SELECT rowid, startdate, enddate, startbalance, currency, account_id"
		sql = sql & " FROM settings WHERE account_id = ?"
		Private id() As String = Array As String(lblaccountname.tag)
		Private rs1  As ResultSet = db.select_query_prepared(sql,id)
		If rs1.NextRow Then
			' get date settings
			DateTime.DateFormat = "yyyy-MM-dd"
			strstartticks = DateTime.DateParse(rs1.GetString("startdate"))
			strendticks = DateTime.DateParse(rs1.GetString("enddate"))
			Log(strstartticks)
			Log(strendticks)
			' get balance and currency settings
			lblbalance.Text = rs1.GetString("startbalance")
			strcurrency = rs1.GetString("currency")
		End If
	End If
	lblcurrency.Text = "Balance (" & strcurrency & ")" & CRLF & "Start: " & lblbalance.Text
	lbltotalexpense.Text = 0
	lbltotalearning.Text = 0
	fill_clv1
	fill_clv2
	cbx1rowids.Initialize
End Sub

Private Sub set_panel_colors(pnl As Panel,clr1 As Int,clr2 As Int)
	Dim lbl As Label = pnl.GetView(0).As(Label)
	lbl.TextColor = clr1
	Dim lbl As Label = pnl.GetView(1).As(Label)
	lbl.TextColor = clr1
	If pnl.NumberOfViews > 2 Then
		Dim lbl As Label = pnl.GetView(2).As(Label)
		lbl.Color = clr2
	End If
End Sub
Private Sub set_colors(pnl As Panel)
	set_panel_colors(pnlnav1,Colors.Black,Colors.Black)
	set_panel_colors(pnlnav2,Colors.Black,Colors.Black)
	set_panel_colors(pnlnav3,Colors.Black,Colors.Black)
	set_panel_colors(pnlnav4,Colors.Black,Colors.Black)
	set_panel_colors(pnlnav5,Colors.Black,Colors.Black)
	set_panel_colors(pnl,Colors.Blue,Colors.Blue)
End Sub

Private Sub fill_cbxaccounts
	Private lst As List
	lst.Initialize
	For i = 0 To B4XPages.MainPage.clvdash.Size -1
		Dim strname As String = B4XPages.MainPage.clvdash.GetRawListItem(i).Value
		lst.Add(strname)
	Next
	cbxaccounts.SetItems(lst)
	cbxaccounts.SelectedIndex = B4XPages.MainPage.selected_account
	lblaccountname.Text = cbxaccounts.SelectedItem
End Sub

Private Sub pnlNavigation_Click
	B4XPages.MainPage.pnlNavigation_Click
End Sub

Private Sub sbtn1_Click
	strtablename = "expenses"
	show_add_dialog("Expense",Colors.ARGB(100,249,177,241))	
End Sub

Private Sub clv1_ItemClick (Index As Int, Value As Object)
	strtablename = "expenses"
	show_change_dialog(Value, "Expense",Colors.ARGB(100,249,177,241))
End Sub

Private Sub sbtn2_Click
	strtablename = "earnings"
	show_add_dialog("Earning",Colors.ARGB(100,158,255,150))
End Sub

Private Sub clv2_ItemClick (Index As Int, Value As Object)
	strtablename = "earnings"
	show_change_dialog(Value, "Earning",Colors.ARGB(100,158,255,150))
End Sub

Private Sub fill_clv1
	clv1.Clear
	DateTime.DateFormat = "yyyy-MM-dd"
	Dim startdate As String = DateTime.Date(strstartticks)
	Private sql As String = "SELECT expenses.rowid, date, category_id, description, amount, name, reference"
	sql = sql & " FROM expenses,category"
	sql = sql & " WHERE expenses.category_id = category.rowid AND date >= '" & startdate & "'"
	sql = sql & " AND expenses.account_id = " & lblaccountname.tag
	sql = sql & " ORDER BY date DESC;"
	Private rs1 As ResultSet = db.select_query(sql)
	Do While rs1.NextRow
		Dim pnl As Panel = clv1_item(rs1)
		clv1.Add(pnl,rs1.GetString("rowid"))
	Loop
End Sub
Private Sub clv1_item(res As ResultSet) As Panel
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0dip, 0dip, clv1.AsView.Width,84dip)
	p.LoadLayout("clv1_item_layout")
	lblcurr.Text = "(" & strcurrency & ")"
	lbl1.Text = res.GetString("date")
	lbl2.Text = "-" & NumberFormat2(res.GetString("amount"),0,2,2,False)
	lblbalance.Text = NumberFormat2(lblbalance.Text - res.GetString("amount"),0,2,2,False)
	lbltotalexpense.Text = NumberFormat2(lbltotalexpense.Text - res.GetString("amount"),0,2,2,False)
	lbl3.Text = res.GetString("name") & " " & res.GetString("reference")
	lbl4.Text = res.GetString("description")
	Return p
End Sub

Private Sub fill_clv2
	clv2.clear
	DateTime.DateFormat = "yyyy-MM-dd"
	Dim startdate As String = DateTime.Date(strstartticks)
	Private sql As String = "SELECT earnings.rowid, date, category_id, description, amount, name, reference"
	sql = sql & " FROM earnings,category"
	sql = sql & " WHERE earnings.category_id = category.rowid AND date >= '" & startdate & "'"
	sql = sql & " AND earnings.account_id = " & lblaccountname.tag
	sql = sql & " ORDER BY date DESC;"
	Private rs1 As ResultSet = db.select_query(sql)
	Do While rs1.NextRow
		Dim pnl As Panel = clv2_item(rs1)
		clv2.Add(pnl,rs1.GetString("rowid"))
	Loop
End Sub
private Sub clv2_item(res As ResultSet) As Panel
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0dip, 0dip, clv2.AsView.Width,84dip)
	p.LoadLayout("clv2_item_layout")
	lblcurr.Text = "(" & strcurrency & ")"
	lbl1.Text = res.GetString("date")
	lbl2.Text = "+" & NumberFormat2(res.GetString("amount"),0,2,2,False)
	lblbalance.Text = NumberFormat2(lblbalance.Text + res.GetString("amount"),0,2,2,False)
	lbltotalearning.Text = "+" & NumberFormat2(lbltotalearning.Text + res.GetString("amount"),0,2,2,False)
	lbl3.Text = res.GetString("name") & " " & res.GetString("reference")
	lbl4.Text = res.GetString("description")
	Return p
End Sub

Private Sub show_add_dialog(title As String,title_color As Int)
	pnl1 = setup_dialog("dbdialog_layout"," Add " & title,title_color)
	lbldate.Text = ""
	ftf1.HintText = "Amount (" & strcurrency & ")"
	ftf1.update
	ftf2.HintText = "Description (optional)"
	ftf2.update
	cbx1rowids.Clear
	Private cbx1lst As List = get_cbx1_items(-1)
	If cbx1lst.Size > 0 Then
		cbx1.SetItems(cbx1lst)
		cbx1.SelectedIndex = 0
		SelectedIndex = 0
		SelectedItem = cbx1.GetItem(SelectedIndex)
	Else
		xui.MsgboxAsync("Add a category first!","Add category")
		Return
	End If
	' settings?
	Private sql As String = "SELECT count(*) as numrecs, account_id"
	sql = sql & " FROM settings WHERE account_id = ?"
	Private id() As String = Array As String(lblaccountname.tag)
	Private rs1  As ResultSet = db.select_query_prepared(sql,id)
	If rs1.NextRow Then
		If rs1.GetString("numrecs") < 1 Then
			xui.MsgboxAsync("Add the settings first!","Add settings")
			Return
		End If
	End If
	ftf1.text = ""
	old_amount = ""
	ftf2.Text = ""
	upd_rowid = ""
	Dim rsub1 As ResumableSub =  dbdialog.ShowCustom(pnl1, "OK", "", "CANCEL")
	Wait For (rsub1) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		Log(lbldate.Text)
		Log(ftf1.Text)
		If ftf1.Text <> "" And lbldate.Text <> "" Then
			db.add_record(strtablename, Array As String(lbldate.Text,cbx1rowids.Get(SelectedIndex),ftf2.Text,ftf1.Text,lblaccountname.Tag))
			B4XPage_Appear
		Else
			xui.MsgboxAsync("Date and amount cannot be empty!","Add " & strtablename)
		End If
	End If
End Sub
private Sub setup_dialog(strlayout As String,lbltext As String,lblcolor As Int) As Panel
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.SetLayoutAnimated(0dip, 0dip, 0dip, 340dip, 200dip)
	pnl.LoadLayout(strlayout)
	Dim lbl As Label
	lbl.Initialize("")
	lbl.Text = lbltext
	lbl.TextSize = 18
	lbl.TextColor = Colors.Black
	lbl.Color = lblcolor
	pnl.AddView(lbl,0dip,0dip,340dip,30dip)
	Return pnl
End Sub
Private Sub show_change_dialog(rowid As Int, title As String, title_color As Int)
	Dim fldlst As List = db.get_fieldnames(strtablename)
	Dim pnl1 As Panel = setup_dialog("dbdialog_layout"," Edit/Delete " & title, title_color)
	Private rs1  As ResultSet = db.find_record(strtablename,rowid)
	If rs1.NextRow Then
		upd_rowid = rs1.GetString(fldlst.Get(0))
		lbldate.Text = rs1.GetString(fldlst.Get(1))
		ftf1.Text = rs1.GetString(fldlst.Get(4))
		old_amount = rs1.GetString(fldlst.Get(4))
		ftf2.Text = rs1.GetString(fldlst.Get(3))
	End If
	ftf1.HintText = "Amount (" & strcurrency & ")"
	ftf1.update
	ftf2.HintText = "Description (optional)"
	ftf2.update
	cbx1rowids.Clear
	Private cbx1lst As List = get_cbx1_items(rs1.GetString(fldlst.Get(2)))
	cbx1.SetItems(cbx1lst)
	cbx1.SelectedIndex = SelectedIndex
	SelectedItem = cbx1.GetItem(SelectedIndex)
	Dim rsub1 As ResumableSub =  dbdialog.ShowCustom(pnl1, "SAVE", "DELETE", "CANCEL")
	Wait For (rsub1) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		If ftf1.Text <> "" And lbldate.Text <> "" Then
			db.change_record(strtablename, Array As String(lbldate.Text,cbx1rowids.Get(SelectedIndex),ftf2.Text,ftf1.Text,lblaccountname.Tag),rowid)
			B4XPage_Appear
		Else
			xui.MsgboxAsync("Date and amount cannot be empty!","Change " & strtablename)
		End If
	else if Result = xui.dialogResponse_Negative Then
		db.remove_record(strtablename,rowid)
		B4XPage_Appear
	End If
End Sub

Sub cbx1_SelectedIndexChanged (Index As Int)
	SelectedIndex = Index
	SelectedItem = cbx1.SelectedItem
End Sub

private Sub get_cbx1_items(upd_id As Int) As List
	Dim lst As List
	lst.Initialize
	Private sql As String = "SELECT rowid, name, reference, account_id FROM category WHERE account_id = ?"
	sql = sql & " ORDER BY sequence"
	Private id() As String = Array As String(lblaccountname.tag)
	Private rs1  As ResultSet = db.select_query_prepared(sql,id)
	Do While rs1.NextRow
		lst.Add(rs1.GetString("name") & " " & rs1.GetString("reference"))
		cbx1rowids.Add(rs1.GetString("rowid"))
		If upd_id = rs1.GetString("rowid") Then
			SelectedIndex = cbx1rowids.IndexOf(rs1.GetString("rowid"))
		End If
	Loop
	Return lst
End Sub

Sub btndate_Click
	lbldate.Text = ""
	datepicker_dialog
End Sub
Sub datepicker_dialog
	lblseldate.Text = ""
	pnlcal.Color = Colors.White
	pnlcal.SetLayoutAnimated(0dip, 0dip, 0dip, 278dip, 368dip)
	pnlcal = cal.set_date_picker(displaymonth,displayyear)
	Dim rsub1 As ResumableSub =  caldialog.ShowCustom(pnlcal, "OK", "", "CANCEL")
	Wait For (rsub1) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		If cal.lblticks > DateTime.Now Then
			xui.MsgboxAsync("Only today and past dates are allowed!",strtablename)
			Return
		End If
		If cal.lblticks < strstartticks Then
			xui.MsgboxAsync("The date is earlier than the starting date!",strtablename)
			Return
		End If
		If cal.lblticks > strendticks Then
			xui.MsgboxAsync("The date is later than the end date!",strtablename)
			Return
		End If
		DateTime.DateFormat = "yyyy-MM-dd"
		lbldate.Text = DateTime.Date(cal.lblticks)
		If old_amount = "" Then
			Dim rsub1 As ResumableSub =  dbdialog.ShowCustom(pnl1, "OK", "", "CANCEL")
		Else
			Dim rsub1 As ResumableSub =  dbdialog.ShowCustom(pnl1, "SAVE", "DELETE", "CANCEL")
		End If
		Wait For (rsub1) Complete (Result As Int)
		If Result = xui.dialogResponse_Positive Then
			Log(lbldate.Text)
			Log(ftf1.Text)
			If ftf1.Text <> "" And lbldate.Text <> ""  Then
				If old_amount = "" Then
					db.add_record(strtablename, Array As String(lbldate.Text,cbx1rowids.Get(SelectedIndex),ftf2.Text,ftf1.Text,lblaccountname.Tag))
				Else
					db.change_record(strtablename, Array As String(lbldate.Text,cbx1rowids.Get(SelectedIndex),ftf2.Text,ftf1.Text,lblaccountname.Tag),upd_rowid)
				End If
				B4XPage_Appear
			Else
				xui.MsgboxAsync("Date and amount cannot be empty!","Add/change " & strtablename)
			End If
		End If
	End If
	If Result = xui.dialogResponse_Negative Then
		lbldate.Text = ""
		Return
	End If
	displayyear = currentyear
	displaymonth = currentmonth
End Sub
Public Sub cal_dayclick
	Dim dayticks As Long = cal.lblticks
	Log(dayticks)	' date ticks value
	DateTime.DateFormat = "yyyy-MM-dd"
	lblseldate.Text = DateTime.Date(dayticks)
End Sub
Sub cal_btnprevclick
	displaymonth = displaymonth - 1
	If displaymonth < 1 Then
		displaymonth = 12
		displayyear = displayyear - 1
	End If
	datepicker_dialog
End Sub
Sub cal_btnnextclick
	displaymonth = displaymonth + 1
	If displaymonth > 12 Then
		displaymonth = 1
		displayyear = displayyear + 1
	End If
	datepicker_dialog
End Sub
Sub cal_btntodayclick
	displaymonth = currentmonth
	displayyear = currentyear
	datepicker_dialog
End Sub

